package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.BuildingUnit;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class BuildingUnitNode extends Renderable{

    private final BuildingUnit buildingUnit;

    public BuildingUnitNode(BuildingUnit buildingUnit) {
        this.buildingUnit = buildingUnit;
    }

    @Override
    public String getText() {
        return buildingUnit.getGmlId().getGmlString();
    }


    @Override
    public void visit(Renderer renderer) {
        renderer.render(buildingUnit);
    }

    @Override
    public void refreshTextColor() {
        if (!buildingUnit.isValidated()) {
            setStatus(CheckStatus.NOT_CHECKED);
        } else if (buildingUnit.containsAnyError()) {
            setStatus(CheckStatus.ERROR);
        } else {
            setStatus(CheckStatus.OK);
        }
    }


}
