package de.hft.stuttgart.citydoctor2.webservice.model.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import de.hft.stuttgart.citydoctor2.webservice.model.ParseStatus;

@Entity
@Table(name = "web_city_doctor_model")
public class WebCityDoctorModel {
	
	@SuppressWarnings("unused")
	private static Logger logger = LogManager.getLogger(WebCityDoctorModel.class);
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Access(AccessType.PROPERTY)
	private int id;
	
	@NotNull
	@Column(name = "file_name")
	private String fileName;
	
	@NotNull
	@Column(name = "parse_status")
	private ParseStatus status;
	
	@NotNull
	@ManyToOne
	private User owner;
	
	@OneToOne(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
	private GmlFile zipFile;
	
	@OneToMany(mappedBy = "model", orphanRemoval = true)
	private List<WebBuilding> buildings = new ArrayList<>();
	
	@OneToMany(mappedBy = "model", orphanRemoval = true)
	private List<Validation> validations = new ArrayList<>();
	
	public List<Validation> getValidations() {
		return validations;
	}

	public void setValidations(List<Validation> validations) {
		this.validations = validations;
	}

	public List<WebBuilding> getBuildings() {
		return buildings;
	}

	public void setBuildings(List<WebBuilding> buildings) {
		this.buildings = buildings;
	}

	public GmlFile getZipFile() {
		return zipFile;
	}

	public void setZipFile(GmlFile zipFile) {
		this.zipFile = zipFile;
	}

	public User getOwner() {
		return owner;
	}

	public void setOwner(User owner) {
		this.owner = owner;
	}

	public ParseStatus getStatus() {
		return status;
	}

	public void setStatus(ParseStatus status) {
		this.status = status;
	}

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}
	
}
